#!/bin/sh

ledoff
nvram set run_sh=on

HEADWORD="3G Scripts"

if [ "$1" != "" ]; then
        dev=$1
else
        dev=`nvram get d3g`
fi
if [ "$2" != "" ]; then
        dev_vid=$2
else
        dev_vid=`nvram get dev_vid`
fi
if [ "$3" != "" ]; then
        dev_pid=$3
else
        dev_pid=`nvram get dev_pid`
fi
if [ "$4" != "" ]; then
        dev_pin=$4
else
        dev_pin=`nvram get wan_3g_pin`
fi

hso_connect.sh down
rmmod hso
rmmod option
rmmod usbserial
rmmod cdc-acm

dev_vid=`get_device_id vid`
echo "get device id is $dev_vid"

echo "[3g.sh] ready to do modeswitch or eject"
sleep 1

#change 3G dongle state to modem
if [ "$dev" = "BandLuxe-C170" ] || [ "$dev" = "ZTE-MF626" ] || [ "$dev_vid" = "0x1a8d" ] || [ "$dev_vid" = "0x19d2" ]; then
	echo "eject cdrom dev"
       	if [ -c "/dev/ttyUSB0" ]; then
		echo "has been ejected"
	else
		i=0
		while [ $i -lt "10" ]; do
			i=`expr $i + 1`
        		if [ ! -b "/dev/sr0" ] && [ ! -b "/dev/sg0" ]
                	then
                		echo "wait $i for sr0/sg0"
                        	sleep 1
                	else
                        	echo "ready to eject sr0/sg0"
                        	sleep 1
                        	break
                	fi
		done
		sdparm --command=eject /dev/sr0
		sdparm --command=eject /dev/sg0
	fi
else	# others
	# always check cdrom device
	if [ -b "/dev/sr0" ] || [ -b "/dev/sg0" ]; then
		sdparm --command=eject /dev/sr0
		sdparm --command=eject /dev/sg0
	fi

      	if [ ! -b "/dev/sr0" ] && [ ! -b "/dev/sg0" ]; then
		echo "start mode_switch"
        	usb_modeswitch -c /etc_ro/usb/g3.conf
	elif [ "$dev_vid" = "0x1bbb" ] || [ "$dev_vid" = "0x12d1" ]; then
		echo "start mode_switch"
        	usb_modeswitch -c /etc_ro/usb/g3.conf
	fi
fi

sleep 1
get_modem_node=`get_modem_node`
echo "(chk1) get modem node is $get_modem_node"

#insmod usbserial module
if [ "$dev" = "MU-Q101" ]; then
        vend_id="0x0408"
        prod_id="0xea02"
elif [ "$dev" = "HUAWEI-E156G" ]; then
        vend_id="0x12d1"
        prod_id="0x1003"
elif [ "$dev" = "Huawei-E161" ]; then
        vend_id="0x12d1"
        prod_id="0x1001"
elif [ "$dev" = "HUAWEI-E169" ]; then
        vend_id="0x12d1"
        prod_id="0x1001"
elif [ "$dev" = "HUAWEI-E220" ]; then
        vend_id="0x12d1"
        prod_id="0x1003"
elif [ "$dev" = "BandLuxe-C170" ]; then
        vend_id="0x1a8d"
        prod_id="0x1009"
elif [ "$dev" = "ZTE-MF626" ]; then
        vend_id="0x19d2"
        prod_id="0x0031"
else	# others
        vend_id=`get_device_id vid`
        prod_id=`get_device_id pid`
fi

echo "usbserial using vid $vend_id pid $prod_id"

if [ "$dev" = "OPTION-ICON225" ] || [ "$dev" = "Option-GlobeTrotter-HSUPA-Modem" ] || [ "$dev" = "Option-iCON-401" ] || [ "$dev" = "Vodafone-K3760" ] || [ "$dev" = "ATT-USBConnect-Quicksilver" ]; then
	echo "using hso"
	#rmmod option
	#rmmod hso
	#rmmod usbserial
	sleep 3
	insmod hso
	sleep 3
elif [ "$get_modem_node" -eq "16" ]; then
        echo "[3g.sh] Using ACM."
	sleep 3
        insmod cdc-acm
else 
	#rmmod option
	#rmmod hso
	#rmmod usbserial
        echo "[3g.sh] Using usbserial"
	sleep 1
	insmod usbserial vendor=$vend_id product=$prod_id
	insmod option
	sleep 3
fi

#DEV_NODE=`nvram get hsdpa_dev_node`

#nvram set modf=$modem_f

user_3g=`nvram get hsdpa_user`
pass_3g=`nvram get hsdpa_pass`
apn_3g=`nvram get hsdpa_apn`
pin_3g=`nvram get wan_3g_pin`
disable_pppd=`nvram get disable_pppd`
baud_3g=`nvram get hsdpa_baud`
EVDO_on=`nvram get EVDO_on`

#if [ "$user_3g" = "" ]; then
#	user_3g=" ";
#fi
#if [ "$pass_3g" = "" ]; then
#	pass_3g=" ";
#fi

sleep 3

#wait for state change and re-enable state
echo "[3g.sh] wait changed state"
if [ "$dev" = "BandLuxe-C170" ] || [ "$dev" = "ZTE-MF626" ]; then
        echo "skip wait"
        nvram set usb3g=on
        sleep 1
else
	i=0
	while [ $i -lt "35" ]; do
		i=`expr $i + 1`
        	usb_state=`nvram get usb3g`
		umode=`nvram get umode`
        	if [ "$usb_state" = "re" ] || [ "$umode" = "done" ]; then
                	echo "ready to re-insmod usbserial/hso"
                	nvram set usb3g=on
                	sleep 1
               		break
		#elif [ -c "/dev/ttyUSB0" ]; then
                #	nvram set usb3g=on
                #	sleep 1
               	#	break
        	else
        		if [ $i == "10" ] || [ $i == "20" ] || [ $i == "25" ] || [ $i == "30" ] || [ $i == "34" ]; then
                		echo "wait $i seconds for switching mode"
			fi
                	sleep 1
        	fi
	done
fi

echo "[3g.sh] chk state: $usb_state, mode: $umode"

if [ "$dev_pin" != "" ] && [ "$dev_pin" != " " ] && [ "$dev_pin" != "  " ] ; then
	echo "disable pin code $dev_pin now"
	#comgt -d /dev/$modem_f -s /etc_ro/ppp/3g/disable_pin.scr &	# disable for tmp
	#sleep 2
else
	echo "not using pin code now"
fi

echo "3g.sh prechk"

if [ "$dev" = "OPTION-ICON225" ] || [ "$dev" = "Option-GlobeTrotter-HSUPA-Modem" ] || [ "$dev" = "Option-iCON-401" ] || [ "$dev" = "Vodafone-K3760" ] || [ "$dev" = "ATT-USBConnect-Quicksilver" ]; then
	if [ "$apn_3g" != "" ]; then
		echo "APN=$apn_3g" > /etc/conninfo.ini
	else
		echo "APN=internet" > /etc/conninfo.ini
	fi
        if [ "$pin_3g" != "" ]; then
                echo "PIN=$pin_3g" >> /etc/conninfo.ini
        fi
	echo "USER=$user_3g"  >> /etc/conninfo.ini
	echo "PASS=$pass_3g"  >> /etc/conninfo.ini
	hso_connect.sh up
else
	if [ "$user_3g" != "" ]; then
		op_user="-u $user_3g"
		if [ "$pass_3g" != "" ]; then
			op_pass="-p $pass_3g"
		fi
	else
		op_user=""
		op_pass=""
	fi

	for i in 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20; do
                        if [ ! -c "/dev/ttyUSB0" ]
                        then
                                echo "wait $i for "/dev/ttyUSB0""
                                sleep 1
                        else
                                echo "ready to call pppd"
                                sleep 1
                                break
                        fi
	done

	#parse_tty
	#sleep 2
	#DEV_NODE=`nvram get hsdpa_dev_node`
	#echo "get tty_node is $DEV_NODE"

	get_modem_node=`get_modem_node`
	echo "get modem node is $get_modem_node"

	if [ "$get_modem_node" -eq "0" ]; then
        	modem_f=ttyUSB0
	elif [ "$get_modem_node" -eq "1" ]; then
        	modem_f=ttyUSB1
	elif [ "$get_modem_node" -eq "2" ]; then
        	modem_f=ttyUSB2
	elif [ "$get_modem_node" -eq "3" ]; then
        	modem_f=ttyUSB3
	elif [ "$get_modem_node" -eq "16" ]; then
        	modem_f=ttyACM0
	else
        	modem_f=ttyUSB0
	fi

        if [ "$EVDO_on" -eq "1" ]; then
                config-3g-ppp.sh $op_user $op_pass -m $modem_f $op_baud -c EVDO_conn.scr -d EVDO_disconn.scr
                echo "[3g.sh] config-3g-ppp.sh $op_pass $op_user -m $modem_f -c EVDO_conn.scr -d EVDO_disconn.scr"
        else
                config-3g-ppp.sh $op_user $op_pass -m $modem_f $op_baud -c Generic_conn.scr -d Generic_disconn.scr
                #config-3g-ppp.sh $op_user $op_pass -m $modem_f $op_baud -c test_conn.scr -d Generic_disconn.scr
                echo "[3g.sh] config-3g-ppp.sh $op_pass $op_user -m $modem_f -c Generic_conn.scr -d Generic_disconn.scr"
        fi

	if [ "$disable_pppd" = "1" ]
	then
		echo "do not run pppd for debug test"
	else
		sleep 1
		pppd call 3g
	fi
fi

nvram set run_sh=off

usb_state=`nvram get usb3g`
if [ "$usb_state" = "on" ]
then
	sleep 20
	nvram set usb3g=
else
	sleep 5
fi

ledon

